# Warewulf shared library
#
# This script is a component of Warewulf,
# http://www.runlevelzero.net/greg/warewulf
#
#########################################################################
#
# Copyright (c) 2003, The Regents of the University of California, through
# Lawrence Berkeley National Laboratory (subject to receipt of any
# required approvals from the U.S. Dept. of Energy).  All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# The GNU GPL Document can be found at:
# http://www.gnu.org/copyleft/gpl.html
#
#########################################################################
#
# Written and maintained by:
#       Greg Kurtzer, <gmkurtzer@lbl.gov>

my $debug = ();
#$debug = 1;

package Warewulf::Config;
use File::Basename;
use Warewulf::Util;
use Socket;
use Exporter;
@ISA = ('Exporter');

@EXPORT = qw(
   &read_conf
   &client_config
);


sub read_conf {
   my ($file, @NULL) = @_;
   my ( %ret );
   open(CONF, "$file");
   while(<CONF>) {
      chomp;
      $_ =~ s/#.*$//g;
      $_ =~ s/^\s+//g;
      $_ =~ s/\s+$//g;
      $_ =~ s/\s*=\s*/=/g;
      if ( $_ =~ /^([a-zA-Z0-9_\s]+)=(.)(.*)(.)$/) {
         $key = $1;
         if ( $ret{"$key"} ) {
            $ret{"$key"} .= " ";
         }
         if ( ( $2 eq '"' and $4 eq '"') or ( $2 eq '\'' and $4 eq '\'') ){
            $ret{"$key"} .= "$3";
         } elsif ( $2 eq '"' or $2 eq '\'' ) {
            $open_quote = '1';
            $ret{"$key"} .= "$3$4";
         } else {
            $ret{"$key"} .= "$2$3$4";
         }
      } elsif ( $open_quote ) {
         if ( $_ =~ /^(.+)(.)$/ ) {
            if ( $2 eq '"' ) {
               $ret{"$key"} .= " $1 ";
               $open_quote = ();
            } else {
               $ret{"$key"} .= " $1$2 ";
            }
         }
      }
   }
   close CONF;
   return %ret;
}

sub client_config {
   my %return = &read_conf("/etc/warewulf/client.conf");
   return(%return);
}



1;
